<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/css/bootstrap.min.css" rel="stylesheet" crossorigin="anonymous">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
  <title>Ticketing System - Events</title>
  <style>
    table {
      width: 100%;
      border-collapse: collapse;
    }
    th, td {
      border: 1px solid black;
      padding: 8px;
      text-align: left;
    }
    th {
      background-color: #f2f2f2;
    }
  </style>
</head>
<body>
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="container-fluid">
      <a class="navbar-brand" href="/">Ticketing System</a>
      <div class="collapse navbar-collapse" id="navbarNav">
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" href="/events">Events</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="/verification">Verification</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="/sellATicket">Sell your ticket</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="usedTickets">Buy a used ticket</a>
          </li>
        </ul>
      </div>
    </div>
  </nav>
  <div class="container">
    <div class="row">
      <div class="col-md-12 mt-5">
        <h1 class="text-center mb-4">Ticketing System - Events</h1>
        <table id="eventsTable" class="table table-striped">
          <thead>
            <tr>
              <th>ID</th>
              <th>Name</th>
              <th>Date</th>
              <th>Location</th>
              <th>Ticket Price</th>
              <th>Total Tickets</th>
              <th>Sold Tickets</th>
              <th>Available Tickets</th>
            </tr>
          </thead>
          <tbody></tbody>
        </table>
      </div>
    </div>
    <div class="row">
      <div class="col-md-6 offset-md-3 mt-5">
        <h2 class="text-center mb-4">Buy Ticket</h2>
        <form id="buyTicketForm">
          <div class="mb-3">
            <label for="address" class="form-label">Your Ethereum Address:</label>
            <input type="text" class="form-control" id="address" name="address">
          </div>
          <div class="mb-3">
            <label for="eventId" class="form-label">Event ID:</label>
            <input type="number" class="form-control" id="eventId" name="eventId">
          </div>
          <div class="mb-3">
            <label for="privateKey" class="form-label">Private Key:</label>
            <input type="password" class="form-control" id="privateKey" name="privateKey">
          </div>
          <button type="submit" class="btn btn-primary">Buy Ticket</button>
        </form>
      </div>
    </div>
  </div>

  
  <script>
document.addEventListener('DOMContentLoaded', async () => {
  const response = await fetch('/fetchEvents');
  const events = await response.json();

  const eventsTable = document.getElementById('eventsTable');
  events.forEach((event) => {
    const row = eventsTable.insertRow(-1);
    row.insertCell(0).innerHTML = event.id;
    row.insertCell(1).innerHTML = event.name;
    row.insertCell(2).innerHTML = new Date(event.date * 1000).toLocaleDateString();
    row.insertCell(3).innerHTML = event.location;
    row.insertCell(4).innerHTML = event.ticketPrice / 1000000000000000000 + ' ETH';
    row.insertCell(5).innerHTML = event.totalTickets;
    row.insertCell(6).innerHTML = event.soldTickets;
    row.insertCell(7).innerHTML = event.totalTickets - event.soldTickets;

  });
});

document.getElementById('buyTicketForm').addEventListener('submit', async (e) => {
  console.log('Form submitted');

  const address = document.getElementById('address').value;
  const eventId = document.getElementById('eventId').value;
  const privateKey = document.getElementById('privateKey').value;

  if (!address || !eventId || !privateKey) {
    alert('Please fill in all of the fields.');
    return;
  }

  try {
    const response = await fetch('/purchaseTicket', {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify({ eventId, privateKey }),
    });

    if (response.ok) {
      alert('Ticket purchased successfully!');
    } else {
      alert('Error purchasing ticket.');
    }
  } catch (error) {
    console.error('Error purchasing ticket:', error);
    alert('Error purchasing ticket.');
  }
  e.preventDefault();

});
</script>
</body>
</html>
